// WARNING: This file is machine generated,
// please do not edit directly!

/*
	Copyright (c) 2008 Robin Vobruba <hoijui.quaero@gmail.com>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _CPPWRAPPER_CLBFEATUREDEFCOLLISIONVOLUMEIMPL_H
#define _CPPWRAPPER_CLBFEATUREDEFCOLLISIONVOLUMEIMPL_H

#include "IncludesHeaders.h"
#include "CollisionVolume.h"

namespace springai {

/**
 * Lets C++ Skirmish AIs call back to the Spring engine.
 *
 * @author	AWK wrapper script
 * @version	GENERATED
 */
class ClbFeatureDefCollisionVolumeImpl : public CollisionVolume {

private:
	AICallback* clb;
	int featureDefId;

	ClbFeatureDefCollisionVolumeImpl(AICallback* clb, int featureDefId);

public:
	virtual int GetFeatureDefId();

	static ClbFeatureDefCollisionVolumeImpl* GetInstance(AICallback* clb, int featureDefId);

public:
	/**
	 * The type of the collision volume's form.
	 * 
	 * @return  "Ell"
	 *          "Cyl[T]" (where [T] is one of ['X', 'Y', 'Z'])
	 *          "Box"
	 */
	const char* GetType();

public:
	/**
	 * The collision volume's full axis lengths.
	 */
	struct SAIFloat3 GetScales();

public:
	/**
	 * The collision volume's offset relative to the feature's center position
	 */
	struct SAIFloat3 GetOffsets();

public:
	/**
	 * Collission test algorithm used.
	 * 
	 * @return  0: discrete
	 *          1: continuous
	 */
	int GetTest();
}; // class ClbFeatureDefCollisionVolumeImpl
} // namespace springai

#endif // _CPPWRAPPER_CLBFEATUREDEFCOLLISIONVOLUMEIMPL_H

